import java.util.Arrays;
import java.util.function.*;

@FunctionalInterface
interface Converter<F, T> { 
	T convert(F from);
}

public class OuterScope {
	public static void main(String[] args) {
		int num = 1;
		System.out.printf("initial value of num: %d%n", num);
		int[] values = new int[1];
		values[0] = num;
		System.out.println(values[0]);
		Converter<Integer, String> stringConverter =
		(from) -> 
			{int loc = num; loc++; values[0] *= 2;
				System.out.printf("value of local var loc %d%n", loc);
				return String.valueOf(from + loc);};
			// {int loc = num; loc++; return String.valueOf(from + loc);};
		// num = num * 10; //final or effectively final
		System.out.printf("after conversion: %s%n", stringConverter.convert(2));
		System.out.println(values[0]);
	}
}
